import os
import sys
import numpy as np
import MDAnalysis
from MDAnalysis import *
import networkx as nx
import seaborn as sns; sns.set()
import matplotlib.pyplot as plt
import math
import random
from MDAnalysis.analysis.distances import distance_array

pd = "/usr/local/gromacs/bin/gmx"
os.system("python ./martinize_3.py -f ./1l2y.pdb -x CG.pdb -ff elnedyn")
os.system(pd+" editconf -f CG.pdb -o CG.gro -center 10 10 10 -box 20 20 20")
os.system(pd+" genconf -f CG.gro -o CG.gro")


def Check(a, b):
    u = Universe(a).select_atoms('name BB')
    v = Universe(b).select_atoms('name BB')
    D1 = distance_array(u.atoms.positions, u.atoms.positions, u.dimensions)
    D2 = distance_array(v.atoms.positions, v.atoms.positions, v.dimensions)
    print (D1-D2)


u = Universe("CG.gro")
#Add_SC_atom_for GLU
#SC*  ---> S#
sc1 = u.select_atoms("name SC1")
sc1.names = ['S1']*sc1.n_atoms
sc1 = u.select_atoms("name SC2")
sc1.names = ['S2']*sc1.n_atoms
sc1 = u.select_atoms("name SC3")
sc1.names = ['S3']*sc1.n_atoms
sc1 = u.select_atoms("name SC4")
sc1.names = ['S4']*sc1.n_atoms
u.atoms.write('mart_s1.gro')

f = open('mart_s1.gro', 'r')
A = f.readlines()[2:-1]
f.close()
A = [i.split() for i in A]


CurrPos = np.array(A)[:,3:].astype(float)
CurrNames = np.array(A)[:,1].astype(str)
CurrResNames = [i[-3:] for i in np.array(A)[:,0]]
CurrResNums = [int(i[:-3]) for i in np.array(A)[:,0]]
CurrAtomIds = np.array(A)[:,2].astype(int)

NewPos = []
NewNames = []
NewResNames = []
NewResNums = []

for i in range(len(CurrPos)):
    NewPos.append(CurrPos[i])
    NewNames.append(CurrNames[i])
    NewResNames.append(CurrResNames[i])
    NewResNums.append(CurrResNums[i])
    #Add backbone dummies
    if CurrNames[i] == 'BB':
        bppos = np.array([CurrPos[i][0], CurrPos[i][1], CurrPos[i][2]+0.141])
        bmpos = np.array([CurrPos[i][0], CurrPos[i][1]+0.142, CurrPos[i][2]])
        NewPos.append(bppos)
        NewPos.append(bmpos)
        NewNames.append('BBp')
        NewNames.append('BBm')
        NewResNums.append(CurrResNums[i])
        NewResNums.append(CurrResNums[i])
        NewResNames.append(CurrResNames[i])
        NewResNames.append(CurrResNames[i])
    if (CurrResNames[i] in ['SER', 'THR', 'ASN', 'GLN']) and (CurrNames[i] == 'S1'):
        bppos = np.array([CurrPos[i][0], CurrPos[i][1], CurrPos[i][2]+0.141])
        bmpos = np.array([CurrPos[i][0], CurrPos[i][1]+0.142, CurrPos[i][2]])
        NewPos.append(bppos)
        NewPos.append(bmpos)
        NewNames.append('S1p')
        NewNames.append('S1m')
        NewResNums.append(CurrResNums[i])
        NewResNums.append(CurrResNums[i])
        NewResNames.append(CurrResNames[i])
        NewResNames.append(CurrResNames[i])
    if (CurrResNames[i] in ['TRP', 'HIS']) and (CurrNames[i] == 'S2'):
        bppos = np.array([CurrPos[i][0], CurrPos[i][1], CurrPos[i][2]+0.141])
        bmpos = np.array([CurrPos[i][0], CurrPos[i][1]+0.142, CurrPos[i][2]])
        NewPos.append(bppos)
        NewPos.append(bmpos)
        NewNames.append('S2p')
        NewNames.append('S2m')
        NewResNums.append(CurrResNums[i])
        NewResNums.append(CurrResNums[i])
        NewResNames.append(CurrResNames[i])
        NewResNames.append(CurrResNames[i])
    if (CurrResNames[i] in ['TYR', 'HIS']) and (CurrNames[i] == 'S3'):
        bppos = np.array([CurrPos[i][0], CurrPos[i][1], CurrPos[i][2]+0.141])
        bmpos = np.array([CurrPos[i][0], CurrPos[i][1]+0.142, CurrPos[i][2]])
        NewPos.append(bppos)
        NewPos.append(bmpos)
        NewNames.append('S3p')
        NewNames.append('S3m')
        NewResNums.append(CurrResNums[i])
        NewResNums.append(CurrResNums[i])
        NewResNames.append(CurrResNames[i])
        NewResNames.append(CurrResNames[i])
    if (CurrResNames[i] in ['GLU']) and (CurrNames[i] == 'S1'):
        Vec = CurrPos[i] - CurrPos[i-1]
        UnitVec = Vec/np.linalg.norm(Vec)
        withmag = 0.27*UnitVec
        NewVec = CurrPos[i] + withmag
        NewPos.append(NewVec)
        NewNames.append('S2')
        NewResNums.append(CurrResNums[i])
        NewResNames.append(CurrResNames[i])   
             
os.system(pd + ' insert-molecules -ci trial.gro -f EG.gro -nmol '+str(len(NewPos))+' -o out.gro')        
u = Universe('out.gro')
u.atoms.names = NewNames
u.atoms.residues.resnames = NewResNames
u.atoms.positions = np.array(NewPos)*10
u.atoms.residues.resnums = NewResNums
u.atoms.residues.resids = NewResNums
u.atoms.write('protein.gro')    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
